#!/bin/python3
#%%
import json, os
from time import time, strftime, localtime, sleep
import requests
# import pandas as pd

#%%
# from shutil import rmtree
# rmtree('./accuweather_response')

#%%
get_time_stamp = lambda : strftime('%Y%m%d%a%H%M%S')
get_time_stamp()

#%%

def json_dump(d: dict, path: str):
    dirname = os.path.dirname(path)
    os.makedirs(dirname, exist_ok=True)
    json.dump(
        d, open(
            path, 'w', 
            encoding='utf-8',
            ),
            ensure_ascii=False,
            indent=4)
    return None


def rq_get(url: str, params: dict):
    print(f"response = requests.get('{url}', params='{params}')")
    response = requests.get(url, params=params)
    if response.status_code == 200:
        response_json = json.loads(response.content.decode('utf-8'))
    else:
        response_json = {}
    print('response_json =', json.dumps(response_json, ensure_ascii=False, indent=4))
    return response_json

loc_key = '58194' # shenzhen
# loc_key = '2332634' # luohu

apikey = 'GhFGXhJd575rDtdOXnoktogjlY3FUA6Z'
details = True

params = {
    'apikey': apikey,
    'details': details,
}

url_dict = {
    'currentconditions_historical_24': f'http://dataservice.accuweather.com/currentconditions/v1/{loc_key}/historical/24',
    'forecasts_hourly_12hour': f'http://dataservice.accuweather.com/forecasts/v1/hourly/12hour/{loc_key}',
    'forecasts_hourly_72hour': f'http://dataservice.accuweather.com/forecasts/v1/hourly/72hour/{loc_key}',
    'forecasts_daily_5day': f'http://dataservice.accuweather.com/forecasts/v1/daily/5day/{loc_key}'
}

params_dict = {
    'currentconditions_historical_24': {
        'apikey': apikey,
        'details': details,
    },
    'forecasts_hourly_12hour': {
        'apikey': apikey,
        'details': details,
        'metric': True,
    },
    'forecasts_daily_5day': {
        'apikey': apikey,
        'details': details,
        'metric': True,
    }
}


#%%

def dump_json_all(tag, timestamp):
    url = url_dict[tag]
    params = params_dict[tag]
    response_json = rq_get(url, params)
    os.makedirs(f'./accuweather_response/{tag}/', exist_ok=True)
    path = f'./accuweather_response/{tag}/{tag}-{loc_key}-{timestamp}.json'
    json_dump(response_json, path)
    return None

flag = False

print('sleep...')
while True:
    dt = localtime()
    if (dt.tm_hour % 2 == 0 and dt.tm_min == 0) or flag:
        flag = False
        timestamp = get_time_stamp()
        print(timestamp)
        dump_json_all('currentconditions_historical_24', timestamp)
        dump_json_all('forecasts_hourly_12hour', timestamp)
        dump_json_all('forecasts_daily_5day', timestamp)
        print('\n\n')
        sleep(61)
    sleep(10)
